---
title: History API
slug: Web/API/History_API
tags:
  - API
  - Advanced
  - HTML DOM
  - History
  - History API
---
<div>{{DefaultAPISidebar("History API")}}</div>

<p>The DOM {{DOMxRef("Window")}} object provides access to the browser's session history (not to be confused for <a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/history">WebExtensions history</a>) through the {{DOMxRef("Window.history","history")}} object. It exposes useful methods and properties that let you navigate back and forth through the user's history, and manipulate the contents of the history stack.</p>

<h2 id="Concepts_and_usage">Concepts and usage</h2>

<p>Moving backward and forward through the user's history is done using the {{DOMxRef("History.back","back()")}}, {{DOMxRef("History.forward","forward()")}}, and {{DOMxRef("History.go","go()")}} methods.</p>

<h3 id="Moving_forward_and_backward">Moving forward and backward</h3>

<p>To move backward through history:</p>

<pre class="brush: js">window.history.back()
</pre>

<p>This acts exactly as if the user clicked on the <kbd><strong>Back</strong></kbd> button in their browser toolbar.</p>

<p>Similarly, you can move forward (as if the user clicked the <kbd><strong>Forward</strong></kbd> button), like this:</p>

<pre class="brush: js">window.history.forward()
</pre>

<h3 id="Moving_to_a_specific_point_in_history">Moving to a specific point in history</h3>

<p>You can use the {{DOMxRef("History.go","go()")}} method to load a specific page from session history, identified by its relative position to the current page. (The current page's relative position is <code>0</code>.)</p>

<p>To move back one page (the equivalent of calling {{DOMxRef("History.back","back()")}}):</p>

<pre class="brush: js">window.history.go(-1)
</pre>

<p>To move forward a page, just like calling {{DOMxRef("History.forward","forward()")}}:</p>

<pre class="brush: js">window.history.go(1)
</pre>

<p>Similarly, you can move forward 2 pages by passing <code>2</code>, and so forth.</p>

<p>Another use for the <code>go()</code> method is to refresh the current page by either passing <code>0</code>, or by invoking it without an argument:</p>

<pre class="brush: js">// The following statements
// both have the effect of
// refreshing the page
window.history.go(0)
window.history.go()
</pre>

<p>You can determine the number of pages in the history stack by looking at the value of the <code>length</code> property:</p>

<pre class="brush: js">let numberOfEntries = window.history.length
</pre>

<h2 id="Interfaces">Interfaces</h2>

<dl>
 <dt>{{domxref("History")}}</dt>
 <dd>Allows manipulation of the browser <em>session history</em> (that is, the pages visited in the tab or frame that the current page is loaded in).</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The following example assigns a listener to the <code>onpopstate</code> property. And then illustrates some of the methods of the history object to add, replace, and move within the browser history for the current tab.</p>

<pre class="brush:js line-numbers language-js">window.onpopstate = function(event) {
  alert(`location: ${document.location}, state: ${JSON.stringify(event.state)}`)
}

history.pushState({page: 1}, "title 1", "?page=1")
history.pushState({page: 2}, "title 2", "?page=2")
history.replaceState({page: 3}, "title 3", "?page=3")
history.back() // alerts "location: http://example.com/example.html?page=1, state: {"page":1}"
history.back() // alerts "location: http://example.com/example.html, state: null"
history.go(2)  // alerts "location: http://example.com/example.html?page=3, state: {"page":3}"</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("HTML WHATWG", "browsers.html#history", "History")}}</td>
   <td>{{Spec2("HTML WHATWG")}}</td>
   <td>No change from {{SpecName("HTML5 W3C")}}.</td>
  </tr>
  <tr>
   <td>{{SpecName("HTML5 W3C", "browsers.html#history", "History")}}</td>
   <td>{{Spec2("HTML5 W3C")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.History")}}</p>

<h2 id="See_also">See also</h2>

<h3 id="References">References</h3>

<ul>
 <li>{{ domxref("window.history") }}</li>
 <li>{{ domxref("window.onpopstate") }}</li>
</ul>

<h3 id="Guides">Guides</h3>

<ul>
 <li><a href="/en-US/docs/Web/API/History_API/Working_with_the_History_API">Working with the History API</a></li>
</ul>
